<template>
  <div class="news-card">
    <img class="news-card__image" :src="imageUrl" />
    <div class="news-card__content">
      <h2 class="news-card__title">{{ title }}</h2>
      <p class="news-card__text">{{ text }}</p>
      <div class="news-card__footer">
        <ProfileSignature
          v-bind="{
            image: authorProfileUrl,
            name: authorName,
            date: formattedDate,
          }"
        />
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from "vue-property-decorator";
import ProfileSignature from "./ProfileSignature.vue";
import dateToString from "@/utils/dateToString.js";

@Component({ components: { ProfileSignature } })
export default class ProjectCard extends Vue {
  @Prop({ required: true }) imageUrl: string;
  @Prop({ required: true }) title: string;
  @Prop({ required: true }) text: string;
  @Prop({ required: true }) authorProfileUrl: string;
  @Prop({ required: true }) authorName: string;
  @Prop({ required: true }) date: Date;

  get formattedDate() {
    return dateToString(this.date);
  }
}
</script>

<style lang="scss" scoped>
.news-card {
  display: flex;
  flex-direction: column;

  &__image {
    display: block;
    width: 100%;
    object-fit: cover;
    height: 240px;
  }

  &__content {
    display: flex;
    flex-direction: column;
    background-color: $white;
    padding: 30px 20px;
    flex: 1 0 auto;
  }

  &__title {
    font-weight: 700;
    font-size: 22px;
    line-height: 1.22;
    color: $blue-gray;
    margin-bottom: 15px;
  }

  &__text {
    color: $blue-gray;
    margin-bottom: 39px;
    font-size: 18px;
    line-height: 1.36;
    text-overflow: ellipsis;
    display: -webkit-box;
    -webkit-line-clamp: 2;
    -webkit-box-orient: vertical;
    overflow: hidden;
  }

  &__footer {
    display: flex;
    flex-direction: column;
    justify-content: flex-end;
    flex: 1 0 auto;
  }
}
</style>
